import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { useCallback } from 'react';
import copy from 'clipboard-copy';
import useMountedState from '../useMountedState';
import useSetState from '../useSetState';
export default function useCopyToClipboard() {
  var isMounted = useMountedState();

  var _useSetState = useSetState({
    value: undefined,
    error: undefined
  }),
      state = _useSetState[0],
      setState = _useSetState[1];

  var copyToClipboard = useCallback( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(value) {
      var normalizedValue, error, _error;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (isMounted()) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return", null);

            case 2:
              _context.prev = 2;

              if (!(typeof value !== 'string' && typeof value !== 'number')) {
                _context.next = 10;
                break;
              }

              error = new Error("Cannot copy typeof " + typeof value + " to clipboard, must be a string");
              if (process.env.NODE_ENV === 'development') console.error(error); // eslint-disable-line no-console

              setState({
                value: value,
                error: error
              });
              return _context.abrupt("return", null);

            case 10:
              if (!(value === '')) {
                _context.next = 15;
                break;
              }

              _error = new Error("Cannot copy empty string to clipboard.");
              if (process.env.NODE_ENV === 'development') console.error(_error); // eslint-disable-line no-console

              setState({
                value: value,
                error: _error
              });
              return _context.abrupt("return", null);

            case 15:
              normalizedValue = value.toString();
              _context.prev = 16;
              _context.next = 19;
              return copy(normalizedValue);

            case 19:
              setState({
                value: normalizedValue,
                error: undefined
              });
              _context.next = 27;
              break;

            case 22:
              _context.prev = 22;
              _context.t0 = _context["catch"](16);
              if (process.env.NODE_ENV === 'development') console.error(_context.t0); // eslint-disable-line no-console

              setState({
                value: value,
                error: _context.t0
              });
              return _context.abrupt("return", null);

            case 27:
              _context.next = 32;
              break;

            case 29:
              _context.prev = 29;
              _context.t1 = _context["catch"](2);
              setState({
                value: normalizedValue,
                error: _context.t1
              });

            case 32:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[2, 29], [16, 22]]);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }(), [isMounted, setState]);
  return [state, copyToClipboard];
}