import _extends from "@babel/runtime/helpers/esm/extends";
import { useState, useCallback } from 'react';
export default function useSetState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useState = useState(initialState),
      state = _useState[0],
      update = _useState[1];

  var setState = useCallback(function (patch) {
    if (patch === void 0) {
      patch = {};
    }

    update(_extends({}, state, patch));
  }, [state]);
  return [state, setState];
}